--print("enter data-updates.lua")

-- local recipeComplexity = {}
-- 
-- local countComplexity
-- countComplexity = function (tname)
--   if recipeComplexity[tname] then
--     if recipeComplexity[tname] == -1 then
--       print("countComplexity error: technology ",tname,"depends on itself");
--       return 1
--     end
--     return recipeComplexity[tname]
--   else
--     --print("Computing complexity for ",tname)
--     recipeComplexity[tname] = -1;  -- mark as entered
--     local c = 1
--     local t = data.raw["technology"][tname]
--     if not t then
--       print("countComplexity error: technology ",tname,"does not exist");
--       recipeComplexity[tname] = 1
--       return 1
--     end
--     if t["prerequisites"] then
--       for p,q in pairs(t["prerequisites"]) do
--         local incr = countComplexity(q)
--         c = c + incr
--         --print("Tech",tname,"gets",incr,"from",q)
--       end
--     end
--     recipeComplexity[tname] = c
--     --print("Final count for",tname,"is",c)
--     return c
--   end
-- end

local recipeDepth = {}

local countDepth
countDepth = function (tname)
  if recipeDepth[tname] then
    if recipeDepth[tname] == -1 then
      print("countDepth error: technology ",tname,"has self as prerequisite");
      -- return zero so that this tech has no effect on current calc
      return 0
    end
    return recipeDepth[tname]
  else
    --print("Computing depth for ",tname)
    recipeDepth[tname] = -1; -- mark as entered
    -- option: could do this without error check by setting 0 on entry.
    local t = data.raw["technology"][tname]
    if not t then
      --print("countDepth error: technology ",tname,"does not exist");
      recipeDepth[tname] = 1
      return 1
    end
    local c = 0
    if t["prerequisites"] then
      for p,q in pairs(t["prerequisites"]) do
        local incr = countDepth(q)
        --print(" -- depth of ",q," is ",incr)
        c = math.max(c,incr)
      end
    end
    local nd = c + 1
    recipeDepth[tname] = nd
    --print("Depth of",tname,"is",nd)
    return nd
  end
end

for p,q in pairs(data.raw["technology"]) do
  --print(p) -- that's the tech name
  --for r,s in pairs(q["unit"]) do
  --  print("  ",r,",",s)
  --end
  --print(p,"c=",q["unit"]["count"],"t=",q["unit"]["time"])
  local d = countDepth(p)
  local oldcount = q["unit"]["count"]
  local newcount = oldcount * d
  --print("Adjust research cost",p,"oldcount",oldcount,"newcount",newcount)
  q["unit"]["count"] = newcount
  -- Increasing the count already increases total time.  Don't do more.
  --q["unit"]["time"] = q["unit"]["time"] * 10
end

--print("exit  data-updates.lua")
